/* 
  project "Evaluations-Platine für Heimautomatisierung"
  created 2013 by Thomas Gauweiler
  copyright: Apache License 2.0, http://www.apache.org/licenses/LICENSE-2.0.html
*/
#define SKETCH_NAME "TRAFFIC LIGHTS"
#define PIN_RED 6
#define PIN_YELLOW 5
#define PIN_GREEN 4

#define RED_ON LOW
#define RED_OFF HIGH
#define YELLOW_ON HIGH
#define YELLOW_OFF LOW
#define GREEN_ON HIGH
#define GREEN_OFF LOW

void switch_all_leds_on() {
  digitalWrite(PIN_RED, RED_ON);
  digitalWrite(PIN_YELLOW, YELLOW_ON);
  digitalWrite(PIN_GREEN, GREEN_ON);
}

void switch_all_leds_off() {
  digitalWrite(PIN_RED, RED_OFF);
  digitalWrite(PIN_YELLOW, YELLOW_OFF);
  digitalWrite(PIN_GREEN, GREEN_OFF);
}

void setup_serial() {
  Serial.begin(9600);
  Serial.print(SKETCH_NAME);
  Serial.println(" is ready");
}

void setup_leds() {
  pinMode(PIN_RED, OUTPUT);
  pinMode(PIN_YELLOW, OUTPUT);
  pinMode(PIN_GREEN, OUTPUT);
  switch_all_leds_on();
  delay(1000);
  switch_all_leds_off();
  delay(1000);
}

void setup() {
  setup_serial();
  setup_leds();
}


/******************************************/

void switch_stop() {
  digitalWrite(PIN_RED, RED_ON);
  digitalWrite(PIN_YELLOW, YELLOW_OFF);
  digitalWrite(PIN_GREEN, GREEN_OFF);
  Serial.println("stop");
}

void switch_ready() {
  digitalWrite(PIN_RED, RED_ON);
  digitalWrite(PIN_YELLOW, YELLOW_ON);
  digitalWrite(PIN_GREEN, GREEN_OFF);
  Serial.println("ready");
}

void switch_go() {
  digitalWrite(PIN_RED, RED_OFF);
  digitalWrite(PIN_YELLOW, YELLOW_OFF);
  digitalWrite(PIN_GREEN, GREEN_ON);
  Serial.println("go");
}

void switch_attention() {
  digitalWrite(PIN_RED, RED_OFF);
  digitalWrite(PIN_YELLOW, YELLOW_ON);
  digitalWrite(PIN_GREEN, GREEN_OFF);
  Serial.println("attention");
}


void loop()
{
  switch_stop();
  delay(2000);
  switch_ready();
  delay(700);
  switch_go();
  delay(2000);
  switch_attention();
  delay(700);
}
